"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_2 = require("@testing-library/react");
const user_event_1 = __importDefault(require("@testing-library/user-event"));
const compositions = __importStar(require("./use-async-request.composition"));
describe('Use async request hook', () => {
    describe('Compositions', () => {
        Object.entries(compositions).forEach(([name, Composition]) => {
            test(name, () => __awaiter(void 0, void 0, void 0, function* () {
                (0, react_2.render)(react_1.default.createElement(Composition, null));
                // @ts-ignore
                if (Composition.waitForReady)
                    yield Composition.waitForReady();
            }));
        });
    });
    describe('Call func on press', () => {
        test('should call func and change response message', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.BasicdemoHook, null));
            expect(react_2.screen.queryByText('world')).not.toBeInTheDocument();
            const callBtn = react_2.screen.getByRole('button', { name: 'Call', exact: true });
            yield user_event_1.default.click(callBtn);
            yield react_2.screen.findByText('world');
        }));
        test.todo('should show loading message');
    });
    describe('Call func on load', () => {
        test('should call func with input args on mount', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.LoadOnMount, null));
            yield react_2.screen.findByText('world');
            yield react_2.screen.findByText('Call count: 1');
        }));
        test('should recall func when pressing call btn', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.LoadOnMount, null));
            yield react_2.screen.findByText('Call count: 1');
            const callBtn = react_2.screen.getByRole('button', { name: 'Call', exact: true });
            yield user_event_1.default.click(callBtn);
            yield react_2.screen.findByText('world');
            yield react_2.screen.findByText('Call count: 2');
        }));
        test('should recall func and override args when pressing call override btn', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.LoadOnMount, null));
            yield react_2.screen.findByText('Call count: 1');
            const callOverrideBtn = react_2.screen.getByRole('button', { name: 'Call override', exact: true });
            yield user_event_1.default.click(callOverrideBtn);
            yield react_2.screen.findByText('sun');
            yield react_2.screen.findByText('Call count: 2');
        }));
        test('should recall func with default args after calling override and pressing call btn', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.LoadOnMount, null));
            yield react_2.screen.findByText('Call count: 1');
            const callOverrideBtn = react_2.screen.getByRole('button', { name: 'Call override', exact: true });
            yield user_event_1.default.click(callOverrideBtn);
            yield react_2.screen.findByText('sun');
            yield react_2.screen.findByText('Call count: 2');
            const callBtn = react_2.screen.getByRole('button', { name: 'Call', exact: true });
            yield user_event_1.default.click(callBtn);
            yield react_2.screen.findByText('world');
            yield react_2.screen.findByText('Call count: 3');
        }));
    });
});
//# sourceMappingURL=use-async-request.fn.test.js.map